[PARAMETER]

ShadowMap1	tex1	value	ShadowMap1

Gras			tex2	value	Ground37BoH.JPG
GrasNormals		tex3	value	Ground37BoH_NRM.png
Stone			tex4	value	Ground06BoH.jpg
StoneNormals	tex5	value	Ground06BoH_NRM.png

GroundMap	tex6	value	../ground.png
FFeld		tex7	value	fussballfeld.png

HMSize		float	settings	heightmap_width
WaterHeight	float	settings	water_height

[VERTEX]

varying vec3 Light;
varying float WaterFactor;

uniform float HMSize;
uniform float WaterHeight;

void main ()
{
	gl_Position= ftransform();
	gl_ClipVertex = gl_ModelViewMatrix * gl_Vertex;	

	vec3 Normal = normalize(gl_NormalMatrix * gl_Normal);
	vec3 Tangent = normalize(gl_NormalMatrix * gl_Color.xyz);
	vec3 Bitangent = cross(Normal, Tangent);

	vec3 tmpLight = normalize(gl_LightSource[0].position.xyz);
	Light.x = dot(tmpLight, Tangent);
	Light.y = dot(tmpLight, Bitangent);
	Light.z = dot(tmpLight, Normal);

	gl_TexCoord[1] = gl_TextureMatrix[1] * gl_ModelViewMatrix * gl_Vertex;

	gl_TexCoord[0] = gl_MultiTexCoord0;

	gl_TexCoord[5].s = gl_Vertex.x/HMSize;
	gl_TexCoord[5].t = -gl_Vertex.z/HMSize;

	if( gl_Vertex.y > WaterHeight )
		WaterFactor = 1.0;
	else
		WaterFactor = gl_Vertex.y / WaterHeight;
	WaterFactor = WaterFactor*WaterFactor;
}

[FRAGMENT]

uniform sampler2DShadow ShadowMap1;
uniform sampler2D Gras;
uniform sampler2D GrasNormals;
uniform sampler2D Stone;
uniform sampler2D StoneNormals;
uniform sampler2D GroundMap;
uniform sampler2D FFeld;

varying vec3 Light;
varying float WaterFactor;

void main ()
{
	vec4 stoneColor = texture2D(Stone,gl_TexCoord[0].st);
	vec3 stoneNormal = texture2D(StoneNormals,gl_TexCoord[0].st).xyz;
	stoneNormal = stoneNormal*2.0 - 1.0;

	vec4 grasColor = texture2D(Gras,gl_TexCoord[0].st);
	vec3 grasNormal = texture2D(GrasNormals,gl_TexCoord[0].st).xyz;
	grasNormal = grasNormal*2.0 - 1.0;

	vec4 ground = texture2D(GroundMap,gl_TexCoord[5].st);

	vec4 diffuse = gl_LightSource[0].diffuse;
	vec4 ambient = gl_LightSource[0].ambient;

	vec3 LV = normalize(Light);
	vec3 NV = normalize(stoneNormal);
	float intensityStone = max(dot(NV,LV),0.0);

	NV = normalize(grasNormal);
	float intensityGras = max(dot(NV,LV),0.0);

	float shadow;
	if( gl_TexCoord[1].x < 0.0 || gl_TexCoord[1].x > 1.0 || gl_TexCoord[1].y < 0.0 || gl_TexCoord[1].y > 1.0 )
	{
		shadow = 1.0;
	}
	else
	{
		float depth = shadow2DProj(ShadowMap1, gl_TexCoord[1]).x;
		shadow = (depth > gl_TexCoord[1].z/gl_TexCoord[1].w) ? 1.0 : 0.3;
	}

	float street;
	if( ground.r > 0.7 )
		street = 1.0;
	else if( ground.r < 0.65 )
		street = 0.0;
	else
		street = (ground.r-0.65)/0.05;

	vec4 ffColor = vec4(0.0,0.0,0.0,0.0);
	if( gl_TexCoord[0].s > 19.0 && gl_TexCoord[0].s < 29.0 &&
	    gl_TexCoord[0].t > 27.6 && gl_TexCoord[0].t <  32.4)
	{
		vec2 ffTexCoord = gl_TexCoord[0].st;
		ffTexCoord.s = (ffTexCoord.s-19.0)/10.0;
		ffTexCoord.t = (ffTexCoord.t-27.6)/4.8;
		ffColor = texture2D(FFeld, ffTexCoord.st);
	}

	vec4 aColor = street*stoneColor + (1.0-street)*grasColor + ffColor;
	vec4 dColor = intensityStone*street*stoneColor + intensityGras*(1.0-street)*grasColor + ffColor;

	gl_FragColor = WaterFactor*aColor*ambient + WaterFactor*dColor*diffuse*shadow;
	gl_FragColor.a = 1.0;
}
